/*!
 * @file        main.c
 *
 * @brief       Main program body
 *
 * @version     V1.0.2
 *
 * @date        2023-03-31
 *
 * @attention
 *
 *  Copyright (C) 2023 Geehy Semiconductor
 *
 *  You may not use this file except in compliance with the
 *  GEEHY COPYRIGHT NOTICE (GEEHY SOFTWARE PACKAGE LICENSE).
 *
 *  The program is only for reference, which is distributed in the hope
 *  that it will be useful and instructional for customers to develop
 *  their software. Unless required by applicable law or agreed to in
 *  writing, the program is distributed on an "AS IS" BASIS, WITHOUT
 *  ANY WARRANTY OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the GEEHY SOFTWARE PACKAGE LICENSE for the governing permissions
 *  and limitations under the License.
 */

/* Includes */
#include "main.h"

/** @addtogroup Examples
  @{
*/

/** @addtogroup ADC_Channel_8
  @{
*/

/** @defgroup ADC_Channel_8_Functions Functions
  @{
*/

/* ADC Single Conversion Init */
void ADC_SingleConvInit(void);
/* ADC Poll */
void ADC_PollSingleConv(void);
/* USART initializtion */
void USART_Init(void);

/*!
 * @brief       Main program
 *
 * @param       None
 *
 * @retval      None
 */
int main(void)
{
    APM_MINI_LEDInit(LED2);
    APM_DelayInit(APM_DELAY_MS);

    APM_MINI_LEDOff(LED2);

    USART_Init();

    /* ADC Continuous Scan Init */
    ADC_SingleConvInit();

    while(1)
    {
        ADC_PollSingleConv();
        APM_MINI_LEDToggle(LED2);
        APM_Delay(500);
    }
}

/*!
 * @brief       ADC Calibration
 *
 * @param       None
 *
 * @retval      None
 */
void ADC_Calibration(void)
{
    uint8_t i = 0;
    int8_t offset = 0;
    uint16_t adcData = 0;

    ADC_SetOffset(0);
    ADC_EnableCompensation();
    ADC_ClearStatusFlag(ADC_FLAG_CC);
    ADC_Enable();
    ADC_StartConversion();

    for(i = 0; i < 10; i++)
    {
        while(ADC_ReadStatusFlag(ADC_FLAG_CC) == RESET);
        ADC_ClearStatusFlag(ADC_FLAG_CC);
    }
    ADC_Disable();

    adcData = ADC_ReadData();
    offset = (int8_t)(0x800 - adcData);
    ADC_SetOffset(offset);

    ADC_DisableCompensation();
    ADC_ClearStatusFlag(ADC_FLAG_CC);
}

/*!
 * @brief       ADC Single conversion initialization
 *
 * @param       None
 *
 * @retval      None
 */
void ADC_SingleConvInit(void)
{
    ADC_Config_T adcConfig;

    ADC_SetMode(ADC_MODE_SINGLE_END);

    /* ADC configuration */
    ADC_ConfigStructInit(&adcConfig);
    adcConfig.channel = ADC_CHANNEL_8;
    adcConfig.convMode = ADC_CONV_MODE_CONTINUOUS;
    adcConfig.interrupt = ADC_INT_CC;
    ADC_Config(&adcConfig);

    /* ADC Calibration */
    ADC_Calibration();

    ADC_Enable();
    ADC_StartConversion();
}

/*!
 * @brief       ADC single conversion in polling mode
 *
 * @param       None
 *
 * @retval      None
 */
void ADC_PollSingleConv(void)
{
    uint16_t adcData = 0;
    uint16_t voltage = 0;

    if(ADC_ReadStatusFlag(ADC_FLAG_CC) == SET)
    {
        ADC_ClearStatusFlag(ADC_FLAG_CC);

        adcData = ADC_ReadData();
        /* voltage(mV) =  adcData * (3300mV / 4095) */
        voltage = (adcData * 3300) / 4095;

        printf("ADC Channel 8 Value:%d\r\n", voltage);
    }
}

/*!
 * @brief       USART Init
 *
 * @param       None
 *
 * @retval      None
 */
void USART_Init(void)
{
    USART_Config_T usartConfig;

    /* 115200 baud rate */
    usartConfig.baudRate = 115200;
    /* No interrupt */
    usartConfig.interrupt = USART_INT_NONE;
    /* Enable transfer */
    usartConfig.mode = USART_MODE_TX;
    /* Parity disable */
    usartConfig.parity = USART_PARITY_NONE;
    /* One stop bit */
    usartConfig.stopBits = USART_STOP_BIT_1;
    /* 8bit Word length */
    usartConfig.wordLength = USART_WORD_LEN_8B;

    /* Enable USART */
    APM_MINI_COMInit(COM1, &usartConfig);
}

#if defined (__CC_ARM) || defined (__ICCARM__) || (defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050))

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @param       *f:  pointer to a FILE that can recording all information
*              needed to control a stream
*
* @retval      The characters that need to be send.
*/
int fputc(int ch, FILE* f)
{
    /* send a byte of data to the serial port */
    USART_TxData8(DEBUG_USART, (uint8_t)ch);

    /* wait for the data to be send */
    while (USART_ReadStatusFlag(DEBUG_USART, USART_FLAG_TXBE) == RESET);

    return (ch);
}

#elif defined (__GNUC__)

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       ch:  The characters that need to be send.
*
* @retval      The characters that need to be send.
*/
int __io_putchar(int ch)
{
    /* send a byte of data to the serial port */
    USART_TxData8(DEBUG_USART, ch);

    /* wait for the data to be send */
    while (USART_ReadStatusFlag(DEBUG_USART, USART_FLAG_TXBE) == RESET);

    return ch;
}

/*!
* @brief       Redirect C Library function printf to serial port.
*              After Redirection, you can use printf function.
*
* @param       file:  Meaningless in this function.
*
* @param       *ptr:  Buffer pointer for data to be sent.
*
* @param       len:  Length of data to be sent.
*
* @retval      The characters that need to be send.
*/
int _write(int file, char* ptr, int len)
{
    int i;
    for (i = 0; i < len; i++)
    {
        __io_putchar(*ptr++);
    }

    return len;
}

#else
#warning Not supported compiler type
#endif

/**@} end of group ADC_Channel_8_Functions */
/**@} end of group ADC_Channel_8 */
/**@} end of group Examples */
